<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "cpn_communication_queue".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "CpnCommunicationQueue".
 *
 * Columns in table "cpn_communication_queue" available as properties of the model,
 * followed by relations of table "cpn_communication_queue" available as properties of the model.
 *
 * The followings are the available columns in table 'cpn_communication_queue':
 * @property integer $id
 * @property string $guid
 * @property integer $cpn_installation_id
 * @property integer $cpn_message_type_id
 * @property integer $processed_flag
 * @property integer $del_flag
 * @property string $url
 * @property string $title
 * @property string $message
 * @property string $message_json
 * @property integer $seconds
 * @property string $date_to_publish
 * @property string $date_expires
 * @property string $date_added
 * @property integer $added_by_account_id
 * @property string $date_updated
 * @property integer $updated_by_account_id
 *
 * The followings are the available model relations:
 * @property Account $addedByAccount
 * @property CpnInstallation $cpnInstallation
 * @property CpnMessageType $cpnMessageType
 * @property Account $updatedByAccount
 */
abstract class BaseCpnCommunicationQueue extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'cpn_communication_queue';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'CpnCommunicationQueue|CpnCommunicationQueues', $n);
    }

    public static function representingColumn()
    {
        return 'guid';
    }

    public function rules()
    {
        // NOTE: you should only define rules for those attributes that
        // will receive user inputs.
        return array(
            array('cpn_installation_id, cpn_message_type_id, url, title, seconds, added_by_account_id', 'required'),
            array('cpn_installation_id, cpn_message_type_id, processed_flag, del_flag, seconds, added_by_account_id, '
                . 'updated_by_account_id', 'numerical', 'integerOnly' => true),
            array('guid, url, title', 'length', 'max' => 255),
            array('message, message_json, date_to_publish, date_expires, date_added, date_updated', 'safe'),
            // The following rule is used by search().
            // @todo Please remove those attributes that should not be searched.
            array('id, guid, cpn_installation_id, cpn_message_type_id, processed_flag, del_flag, url, title, '
                . 'message, message_json, seconds, date_to_publish, date_expires, date_added, added_by_account_id, '
                . 'date_updated, updated_by_account_id', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        // NOTE: you may need to adjust the relation name and the related
        // class name for the relations automatically generated below.
        return array(
            'addedByAccount' => array(self::BELONGS_TO, 'Account', 'added_by_account_id'),
            'cpnInstallation' => array(self::BELONGS_TO, 'CpnInstallation', 'cpn_installation_id'),
            'cpnMessageType' => array(self::BELONGS_TO, 'CpnMessageType', 'cpn_message_type_id'),
            'updatedByAccount' => array(self::BELONGS_TO, 'Account', 'updated_by_account_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => 'ID',
            'guid' => 'Guid',
            'cpn_installation_id' => 'Cpn Installation',
            'cpn_message_type_id' => 'Cpn Message Type',
            'processed_flag' => 'Processed Flag',
            'del_flag' => 'Del Flag',
            'url' => 'Url',
            'title' => 'Title',
            'message' => 'Message',
            'message_json' => 'Message Json',
            'seconds' => 'Seconds',
            'date_to_publish' => 'Date To Publish',
            'date_expires' => 'Date Expires',
            'date_added' => 'Date Added',
            'added_by_account_id' => 'Added By Account',
            'date_updated' => 'Date Updated',
            'updated_by_account_id' => 'Updated By Account',
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('guid', $this->guid, true);
        $criteria->compare('cpn_installation_id', $this->cpn_installation_id);
        $criteria->compare('cpn_message_type_id', $this->cpn_message_type_id);
        $criteria->compare('processed_flag', $this->processed_flag);
        $criteria->compare('del_flag', $this->del_flag);
        $criteria->compare('url', $this->url, true);
        $criteria->compare('title', $this->title, true);
        $criteria->compare('message', $this->message, true);
        $criteria->compare('message_json', $this->message_json, true);
        $criteria->compare('seconds', $this->seconds);
        $criteria->compare('date_to_publish', $this->date_to_publish, true);
        $criteria->compare('date_expires', $this->date_expires, true);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('added_by_account_id', $this->added_by_account_id);
        $criteria->compare('date_updated', $this->date_updated, true);
        $criteria->compare('updated_by_account_id', $this->updated_by_account_id);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
